#!/usr/bin/env python
#
# Copyright 2007 Google Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#




"""Conversion API module."""

from conversion import *

__all__ = [

    "BackendDeadlineExceeded",
    "BackendError",
    "ConversionUnsupported",
    "ConversionTooLarge",
    "Error",
    "InvalidRequest",
    "TooManyConversions",
    "TransientError",

    "CONVERSION_MAX_DOC_SIZE_BYTES",
    "CONVERSION_MAX_NUM_PER_REQUEST",

    "Asset",
    "ConversionOutput",
    "ConversionRequest",
    "convert",
    "create_rpc",
    "make_convert_call",
    ]
